OGRE-Next: Ogre::D3D11GpuProgramManager Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Public Member Functions | List of all members
Ogre::D3D11GpuProgramManager Class Referencefinal

`#include <OgreD3D11GpuProgramManager.h>`

Inheritance diagram for Ogre::D3D11GpuProgramManager:
[legend]

## Public Member Functions
| D3D11GpuProgramManager ()
| ~D3D11GpuProgramManager () override
Public Member Functions inherited from Ogre::GpuProgramManager
| GpuProgramManager ()
virtual | ~GpuProgramManager ()
virtual void | addMicrocodeToCache (const String &source, const Microcode &microcode)
| Adds a microcode for a program to the microcode cache.
bool | canGetCompiledShaderBuffer ()
virtual void | clearMicrocodeCache ()
| Deletes all microcodes. Useful when hot reloading.
virtual ResourcePtr | create (const String &name, const String &group, GpuProgramType gptype, const String &syntaxCode, bool isManual=false, ManualResourceLoader *loader=0)
| General create method, using specific create parameters instead of name / value pairs.
virtual Microcode | createMicrocode (const uint32 size) const
| Creates a microcode to be later added to the cache.
virtual GpuProgramParametersSharedPtr | createParameters ()
| Creates a new GpuProgramParameters instance which can be used to bind parameters to your programs.
virtual GpuProgramPtr | createProgram (const String &name, const String &groupName, const String &filename, GpuProgramType gptype, const String &syntaxCode)
| Create a new, unloaded GpuProgram from a file of assembly.
virtual GpuProgramPtr | createProgramFromString (const String &name, const String &groupName, const String &code, GpuProgramType gptype, const String &syntaxCode)
| Create a GPU program from a string of assembly code.
virtual GpuSharedParametersPtr | createSharedParameters (const String &name)
| Create a new set of shared parameters, which can be used across many GpuProgramParameters objects of different structures.
virtual const SharedParametersMap & | getAvailableSharedParameters () const
| Get (const) access to the available shared parameter sets.
GpuProgramPtr | getByName (const String &name, bool preferHighLevelPrograms=true)
| Get a resource by name.
virtual const Microcode & | getMicrocodeFromCache (const String &source) const
| Returns a microcode for a program from the microcode cache.
ResourcePtr | getResourceByName (const String &name, bool preferHighLevelPrograms=true)
| Overrides the standard ResourceManager getResourceByName method.
bool | getSaveMicrocodesToCache ()
| Get if the microcode of a shader should be saved to a cache.
virtual GpuSharedParametersPtr | getSharedParameters (const String &name) const
| Retrieve a set of shared parameters, which can be used across many GpuProgramParameters objects of different structures.
virtual const SyntaxCodes & | getSupportedSyntax () const
| Returns the syntaxes that this manager supports.
bool | isCacheDirty () const
| Returns true if the microcodecache changed during the run.
virtual bool | isMicrocodeAvailableInCache (const String &source) const
| Check if a microcode is available for a program in the microcode cache.
virtual bool | isSyntaxSupported (const String &syntaxCode) const
| Returns whether a given syntax code (e.g.
virtual GpuProgramPtr | load (const String &name, const String &groupName, const String &filename, GpuProgramType gptype, const String &syntaxCode)
| Loads a GPU program from a file of assembly.
virtual GpuProgramPtr | loadFromString (const String &name, const String &groupName, const String &code, GpuProgramType gptype, const String &syntaxCode)
| Loads a GPU program from a string of assembly code.
virtual void | loadMicrocodeCache (DataStreamPtr stream)
| Loads the microcode cache from disk.
virtual void | removeMicrocodeFromCache (const String &source)
| Removes a microcode for a program from the microcode cache.
virtual void | saveMicrocodeCache (DataStreamPtr stream) const
| Saves the microcode cache to disk.
void | setSaveMicrocodesToCache (const bool val)
| Set if the microcode of a shader should be saved to a cache.
Public Member Functions inherited from Ogre::ResourceManager
| ResourceManager ()
| ~ResourceManager () override
virtual void | _notifyResourceLoaded (Resource *res)
| Notify this manager that a resource which it manages has been loaded.
virtual void | _notifyResourceTouched (Resource *res)
| Notify this manager that a resource which it manages has been 'touched', i.e.
virtual void | _notifyResourceUnloaded (Resource *res)
| Notify this manager that a resource which it manages has been unloaded.
virtual ResourceCreateOrRetrieveResult | createOrRetrieve (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Create a new resource, or retrieve an existing one with the same name if it already exists.
virtual ResourcePtr | createResource (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Creates a new blank resource, but does not immediately load it.
void | destroyAllResourcePools ()
| destroy all pools
void | destroyResourcePool (const String &name)
| Destroy a resource pool.
void | destroyResourcePool (ResourcePool *pool)
| Destroy a resource pool.
virtual ResourcePtr | getByHandle (ResourceHandle handle)
| Retrieves a pointer to a resource by handle, or null if the resource does not exist.
Real | getLoadingOrder () const override
| Gets the relative loading order of resources of this type.
virtual size_t | getMemoryBudget () const
| Get the limit on the amount of memory this resource handler may use.
virtual size_t | getMemoryUsage () const
| Gets the current memory usage, in bytes.
virtual ResourcePtr | getResourceByName (const String &name, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| Retrieves a pointer to a resource by name, or null if the resource does not exist.
ResourceMapIterator | getResourceIterator ()
| Returns an iterator over all resources in this manager.
ResourcePool * | getResourcePool (const String &name)
| Create a resource pool, or reuse one that already exists.
const String & | getResourceType () const
| Gets a string identifying the type of resource this manager handles.
const StringVector & | getScriptPatterns () const override
| Gets the file patterns which should be used to find scripts for this ResourceManager.
virtual bool | getVerbose ()
| Gets whether this manager and its resources habitually produce log output.
void | parseScript (DataStreamPtr &stream, const String &groupName) override
| Parse the definition of a set of resources from a script file.
virtual ResourcePtr | prepare (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *loadParams=0, bool backgroundThread=false)
| Generic prepare method, used to create a Resource specific to this ResourceManager without using one of the specialised 'prepare' methods (containing per-Resource-type parameters).
void | reloadAll (bool reloadableOnly=true)
| Caused all currently loaded resources to be reloaded.
virtual void | reloadAll (Resource::LoadingFlags flags)
| Caused all currently loaded resources to be reloaded.
void | reloadUnreferencedResources (bool reloadableOnly=true)
| Caused all currently loaded but not referenced by any other object resources to be reloaded.
virtual void | remove (const ResourcePtr &r)
| Remove a single resource.
virtual void | remove (const String &name)
| Remove a single resource by name.
virtual void | remove (ResourceHandle handle)
| Remove a single resource by handle.
virtual void | removeAll ()
| Removes all resources.
virtual void | removeUnreferencedResources (bool reloadableOnly=true)
| Remove all resources which are not referenced by any other object.
virtual bool | resourceExists (const String &name)
| Returns whether the named resource exists in this manager.
virtual bool | resourceExists (ResourceHandle handle)
| Returns whether a resource with the given handle exists in this manager.
virtual void | setMemoryBudget (size_t bytes)
| Set a limit on the amount of memory this resource handler may use.
virtual void | setVerbose (bool v)
| Sets whether this manager and its resources habitually produce log output.
virtual void | unload (const String &name)
| Unloads a single resource by name.
virtual void | unload (ResourceHandle handle)
| Unloads a single resource by handle.
void | unloadAll (bool reloadableOnly=true)
| Unloads all resources.
virtual void | unloadAll (Resource::LoadingFlags flags)
| Unloads all resources.
void | unloadUnreferencedResources (bool reloadableOnly=true)
| Unload all resources which are not referenced by any other object.
Public Member Functions inherited from Ogre::ScriptLoader
virtual | ~ScriptLoader ()
Public Member Functions inherited from Ogre::Singleton< GpuProgramManager >
| Singleton ()
| ~Singleton ()

## Additional Inherited Members
Public Types inherited from Ogre::GpuProgramManager
typedef MemoryDataStreamPtr | Microcode
typedef map< Hash, Microcode >::type | MicrocodeMap
typedef map< String, GpuSharedParametersPtr >::type | SharedParametersMap
typedef set< String >::type | SyntaxCodes
Public Types inherited from Ogre::ResourceManager
typedef std::pair< ResourcePtr, bool > | ResourceCreateOrRetrieveResult
typedef map< ResourceHandle, ResourcePtr >::type | ResourceHandleMap
typedef unordered_map< String, ResourcePtr >::type | ResourceMap
typedef MapIterator< ResourceHandleMap > | ResourceMapIterator
typedef unordered_map< String, ResourceMap >::type | ResourceWithGroupMap
Static Public Member Functions inherited from Ogre::GpuProgramManager
static GpuProgramManager & | getSingleton ()
| Override standard Singleton retrieval.
static GpuProgramManager * | getSingletonPtr ()
| Override standard Singleton retrieval.
Static Public Member Functions inherited from Ogre::Singleton< GpuProgramManager >
static GpuProgramManager & | getSingleton ()
static GpuProgramManager * | getSingletonPtr ()
Public Attributes inherited from Ogre::ResourceManager
| OGRE_AUTO_MUTEX

## Constructor & Destructor Documentation

## ◆ D3D11GpuProgramManager()

Ogre::D3D11GpuProgramManager::D3D11GpuProgramManager | ( |  | ) |

## ◆ ~D3D11GpuProgramManager()

Ogre::D3D11GpuProgramManager::~D3D11GpuProgramManager | ( |  | ) |
| override

The documentation for this class was generated from the following file:

- OgreD3D11GpuProgramManager.h